import { LoadInput } from "../common.ts";
import { ParseLotteryCards } from "./4_common.ts";

const tests = [
    "Card 1: 41 48 83 86 17 | 83 86  6 31 17  9 48 53",
    "Card 2: 13 32 20 16 61 | 61 30 68 82 17 32 24 19",
    "Card 3:  1 21 53 59 44 | 69 82 63 72 16 21 14  1",
    "Card 4: 41 92 73 84 69 | 59 84 76 51 58  5 54 83",
    "Card 5: 87 83 26 28 32 | 88 30 70 12 93 22 82 36",
    "Card 6: 31 18 13 56 72 | 74 77 10 23 35 67 36 11",
];

const input = await LoadInput(4);

// Parse the cards
const parsedCards = ParseLotteryCards(input);

// Find the sum of the "points" of the card
// "Points" == 2^(amount of winning numbers - 1)
const sumOfCardPoints = parsedCards.reduce((accumulator, card) => {
    if (card.NumberOfWins) { accumulator += Math.pow(2, card.NumberOfWins - 1); }
    return accumulator;
}, 0);

console.log(`The total points for these cards is: ${sumOfCardPoints}`);
